module jp.ku6.windows.win32api.basetsd;

alias const(void)* HANDLE;
alias HANDLE* PHANDLE, LPHANDLE;

alias byte   INT8;
alias short  INT16;
alias int    INT32;
alias long   INT64;
alias ubyte  UINT8;
alias ushort UINT16;
alias uint   UINT32;
alias int    LONG32;
alias uint   ULONG32;
alias uint   DWORD32;
alias long   LONG64;
alias ulong  ULONG64;
alias ulong  UINT64;
alias long   LONGLONG;
alias ulong  ULONGLONG;
alias ulong  DWORD64;

alias byte*   PINT8;
alias short*  PINT16;
alias int*    PINT32;
alias long*   PINT64;
alias ubyte*  PUINT8;
alias ushort* PUINT16;
alias uint*   PUINT32;
alias int*    PLONG32;
alias int*    PULONG32;
alias int*    PDWORD32;
alias ulong*  PUINT64;
alias long*   PLONG64;
alias ulong*  PULONG64;
alias ulong*  PDWORD64;

version (Win64)
{
	immutable ulong ADDRESS_TAG_BIT = 0x40000000000;

	alias long  INT_PTR;
	alias long  LONG_PTR;
	alias ulong UINT_PTR;
	alias ulong ULONG_PTR;
	alias long  SHANDLE_PTR;
	alias ulong HANDLE_PTR;
	alias int   HALF_PTR;
	alias uint  UHALF_PTR;

	alias long*  PINT_PTR;
	alias long*  PLONG_PTR;
	alias ulong* PUINT_PTR;
	alias ulong* PULONG_PTR;
	alias int*   PHALF_PTR;
	alias uint*  PUHALF_PTR;

	alias uint  POINTER_32;
	alias void* POINTER_64;

	short  PtrToShort(const(void*) ptr)       { return cast(short)ptr; }
	int    PtrToInt(const(void*) ptr)         { return cast(int)ptr; }
	int    PtrToLong(const(void*) ptr)        { return cast(int)ptr; }
	int    HandleToLong(const(void*) handle)  { return cast(int)handle; }
	ushort PtrToUshort(const(void*) ptr)      { return cast(ushort)ptr; }
	uint   PtrToUint(const(void*) ptr)        { return cast(uint)ptr; }
	uint   PtrToUlong(const(void*) ptr)       { return cast(uint)ptr; }
	uint   HandleToULong(const(void*) handle) { return cast(uint)handle; }
	void* IntToPtr(int i)            { return cast(void*)i; }
	void* LongToPtr(int l)           { return cast(void*)l; }
	void* LongToHandle(int handle)   { return cast(void*)handle; }
	void* UIntToPtr(uint i)          { return cast(void*)i; }
	void* ULongToPtr(uint l)         { return cast(void*)l; }
	void* ULongToHandle(uint handle) { return cast(void*)handle; }

	POINTER_64 PtrToPtr64(void* ptr) { return ptr; }
	void* Ptr64ToPtr(POINTER_64 ptr) { return ptr; }

	alias PtrToPtr64 HandleToHandle64;
	alias Ptr64ToPtr Handle64ToHandle;

	void* Ptr32ToPtr(POINTER_32 ptr) { return cast(void*)ptr; }
	POINTER_32 PtrToPtr32(void* ptr) { return cast(POINTER_32)ptr; }

	alias Ptr32ToPtr Handle32ToHandle;
	alias PtrToPtr32 HandleToHandle32;
}
else
{
	immutable uint ADDRESS_TAG_BIT = 0x80000000;

	alias int    INT_PTR;
	alias int    LONG_PTR;
	alias int    SHANDLE_PTR;
	alias uint   UINT_PTR;
	alias uint   ULONG_PTR;
	alias uint   HANDLE_PTR;
	alias short  HALF_PTR;
	alias ushort UHALF_PTR;

	alias int*    PINT_PTR;
	alias int*    PLONG_PTR;
	alias uint*   PUINT_PTR;
	alias uint*   PULONG_PTR;
	alias short*  PHALF_PTR;
	alias ushort* PUHALF_PTR;

	alias void*  POINTER_32;
	alias ulong  POINTER_64;

	short  PtrToShort(const(void*) ptr)       { return cast(short)ptr; }
	int    PtrToInt(const(void*) ptr)         { return cast(int)ptr; }
	int    PtrToLong(const(void*) ptr)        { return cast(int)ptr; }
	int    HandleToLong(const(void*) handle)  { return cast(int)handle; }
	ushort PtrToUshort(const(void*) ptr)      { return cast(ushort)ptr; }
	uint   PtrToUint(const(void*) ptr)        { return cast(uint)ptr; }
	uint   PtrToUlong(const(void*) ptr)       { return cast(uint)ptr; }
	uint   HandleToULong(const(void*) handle) { return cast(uint)handle; }
	void* IntToPtr(int i)            { return cast(void*)i; }
	void* LongToPtr(int l)           { return cast(void*)l; }
	void* LongToHandle(int handle)   { return cast(void*)handle; }
	void* UIntToPtr(uint i)          { return cast(void*)i; }
	void* ULongToPtr(uint l)         { return cast(void*)l; }
	void* ULongToHandle(uint handle) { return cast(void*)handle; }


	POINTER_64 PtrToPtr64(void* ptr) { return cast(POINTER_64)ptr; }
	void* Ptr64ToPtr(POINTER_64 ptr) { return cast(void*)ptr; }

	alias PtrToPtr64 HandleToHandle64;
	alias Ptr64ToPtr Handle64ToHandle;

	void* Ptr32ToPtr(POINTER_32 ptr) { return ptr; }
	POINTER_32 PtrToPtr32(void* ptr) { return ptr; }

	alias Ptr32ToPtr Handle32ToHandle;
	alias PtrToPtr32 HandleToHandle32;
}

alias HandleToULong HandleToUlong;
alias ULongToHandle UlongToHandle;
alias ULongToPtr    UlongToPtr;
alias UIntToPtr     UintToPtr;

alias LONG_PTR  SSIZE_T;
alias ULONG_PTR SIZE_T;
alias ULONG_PTR DWORD_PTR;
alias ULONG_PTR KAFFINITY;

alias LONG_PTR*  PSSIZE_T;
alias ULONG_PTR* PSIZE_T;
alias ULONG_PTR* PDWORD_PTR;
alias KAFFINITY* PKAFFINITY;

enum : UINT_PTR  { MAXUINT_PTR = UINT_PTR.max }
enum : INT_PTR   { MAXINT_PTR = INT_PTR.max, MININT_PTR = INT_PTR.min }
enum : ULONG_PTR { MAXULONG_PTR = ULONG_PTR.max }
enum : LONG_PTR  { MAXLONG_PTR = LONG_PTR.max, MINLONG_PTR = LONG_PTR.min }
enum : UHALF_PTR { MAXUHALF_PTR = UHALF_PTR.max }
enum : HALF_PTR  { MAXHALF_PTR = HALF_PTR.max, MINHALF_PTR = HALF_PTR.min }
enum : UINT8 { MAXUINT8 = UINT8.max }
enum : INT8  { MAXINT8 = INT8.max, MININT8 = INT8.min }
enum : UINT16 { MAXUINT16 = UINT16.max }
enum : INT16  { MAXINT16 = INT16.max, MININT16 = INT16.min }
enum : UINT32 { MAXUINT32 = UINT32.max }
enum : INT32  { MAXINT32 = INT32.max, MININT32 = INT32.min }
enum : UINT64 { MAXUINT64 = UINT64.max }
enum : INT64  { MAXINT64 = INT64.max, MININT64 = INT64.min }
enum : ULONG32 { MAXULONG32 = ULONG32.max }
enum : LONG32  { MAXLONG32 = LONG32.max, MINLONG32 = LONG32.min }
enum : ULONG64 { MAXULONG64 = ULONG64.max }
enum : LONG64  { MAXLONG64 = LONG64.max, MINLONG64 = LONG64.min }
enum : ULONGLONG  { MAXULONGLONG = ULONGLONG.max }
enum : LONGLONG  { MAXLONGLONG = LONGLONG.max, MINLONGLONG = LONGLONG.min }
enum : SIZE_T  { MAXSIZE_T = SIZE_T.max }
enum : LONGLONG  { MAXSSIZE_T = SSIZE_T.max, MINSSIZE_T = SSIZE_T.min }
enum : uint  { MAXUINT = uint.max }
enum : int  { MAXINT = int.max, MININT = int.min }
enum : DWORD32  { MAXDWORD32 = DWORD32.max }
enum : DWORD64  { MAXDWORD64 = DWORD64.max }

