module jp.ku6.windows.win32api.propsys;

import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.unknwn;
import jp.ku6.windows.win32api.wtypes;
import jp.ku6.windows.win32api.shtypes;
import jp.ku6.windows.win32api.oaidl;
import jp.ku6.windows.win32api.objidl;
import jp.ku6.windows.win32api.ocidl;
import jp.ku6.windows.win32api.propidl;
import jp.ku6.windows.win32api.rpcdcep;
import jp.ku6.windows.win32api.structuredquerycondition;


extern (Windows):

immutable IID IID_IInitializeWithFile = {0xb7d14566, 0x0509, 0x4cce, [0xa7, 0x1f, 0x0a, 0x55, 0x42, 0x33, 0xbd, 0x9b]};
interface IInitializeWithFile : IUnknown
{
	HRESULT Initialize(LPCWSTR pszFilePath, DWORD grfMode);
}


immutable IID IID_IInitializeWithStream = {0xb824b49d, 0x22ac, 0x4161, [0xac, 0x8a, 0x99, 0x16, 0xe8, 0xfa, 0x3f, 0x7f]};
interface IInitializeWithStream : IUnknown
{
	HRESULT Initialize(IStream pstream, DWORD grfMode);
}

HRESULT IInitializeWithStream_RemoteInitialize_Proxy(IInitializeWithStream This, IStream pstream, DWORD grfMode);
void IInitializeWithStream_RemoteInitialize_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer,PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IPropertyStore = {0x886d8eeb, 0x8cf2, 0x4446, [0x8d, 0x02, 0xcd, 0xba, 0x1d, 0xbd, 0xcf, 0x99]};
interface IPropertyStore : IUnknown
{
	HRESULT GetCount(DWORD* cProps);
	HRESULT GetAt(DWORD iProp, PROPERTYKEY* pkey);
	HRESULT GetValue(REFPROPERTYKEY key, PROPVARIANT* pv);
	HRESULT SetValue(REFPROPERTYKEY key, REFPROPVARIANT propvar);
	HRESULT Commit();
}
alias IPropertyStore LPPROPERTYSTORE;

immutable IID IID_INamedPropertyStore = {0x71604b0f, 0x97b0, 0x4764, [0x85, 0x77, 0x2f, 0x13, 0xe9, 0x8a, 0x14, 0x22]};
interface INamedPropertyStore : IUnknown
{
	HRESULT GetNamedValue(LPCWSTR pszName, PROPVARIANT* ppropvar);
	HRESULT SetNamedValue(LPCWSTR pszName, REFPROPVARIANT propvar);
	HRESULT GetNameCount(DWORD* pdwCount);
	HRESULT GetNameAt(DWORD iProp, BSTR* pbstrName);
}


alias DWORD GETPROPERTYSTOREFLAGS;
immutable DWORD GPS_DEFAULT               = 0;
immutable DWORD GPS_HANDLERPROPERTIESONLY = 0x1;
immutable DWORD GPS_READWRITE             = 0x2;
immutable DWORD GPS_TEMPORARY             = 0x4;
immutable DWORD GPS_FASTPROPERTIESONLY    = 0x8;
immutable DWORD GPS_OPENSLOWITEM          = 0x10;
immutable DWORD GPS_DELAYCREATION         = 0x20;
immutable DWORD GPS_BESTEFFORT            = 0x40;
immutable DWORD GPS_NO_OPLOCK             = 0x80;
immutable DWORD GPS_MASK_VALID            = 0xff;

immutable IID IID_IObjectWithPropertyKey = {0xfc0ca0a7, 0xc316, 0x4fd2, [0x90, 0x31, 0x3e, 0x62, 0x8e, 0x6d, 0x4f, 0x23]};
interface IObjectWithPropertyKey : IUnknown
{
	HRESULT SetPropertyKey(REFPROPERTYKEY key);
	HRESULT GetPropertyKey(PROPERTYKEY* pkey);
}

enum PKA_FLAGS
{
	PKA_SET,
	PKA_APPEND,
	PKA_DELETE,
}

immutable IID IID_IPropertyChange = {0xf917bc8a, 0x1bba, 0x4478, [0xa2, 0x45, 0x1b, 0xde, 0x03, 0xeb, 0x94, 0x31]};
interface IPropertyChange : IObjectWithPropertyKey
{
	HRESULT ApplyToPropVariant(REFPROPVARIANT propvarIn, PROPVARIANT* ppropvarOut);
}

immutable IID IID_IPropertyChangeArray = {0x380f5cad, 0x1b5e, 0x42f2, [0x80, 0x5d, 0x63, 0x7f, 0xd3, 0x92, 0xd3, 0x1e]};
interface IPropertyChangeArray : IUnknown
{
	HRESULT GetCount(UINT* pcOperations);
	HRESULT GetAt(UINT iIndex, REFIID riid, void** ppv);
	HRESULT InsertAt(UINT iIndex, IPropertyChange ppropChange);
	HRESULT Append(IPropertyChange ppropChange);
	HRESULT AppendOrReplace(IPropertyChange ppropChange);
	HRESULT RemoveAt(UINT iIndex);
	HRESULT IsKeyInArray(REFPROPERTYKEY key);
}

immutable IID IID_IPropertyStoreCapabilities = {0xc8e2d566, 0x186e, 0x4d49, [0xbf, 0x41, 0x69, 0x09, 0xea, 0xd5, 0x6a, 0xcc]};
interface IPropertyStoreCapabilities : IUnknown
{
	HRESULT IsPropertyWritable(REFPROPERTYKEY key);
}

enum PSC_STATE
{
	PSC_NORMAL,
	PSC_NOTINSOURCE,
	PSC_DIRTY,
	PSC_READONLY,
}

immutable IID IID_IPropertyStoreCache = {0x3017056d, 0x9a91, 0x4e90, [0x93, 0x7d, 0x74, 0x6c, 0x72, 0xab, 0xbf, 0x4f]};
interface IPropertyStoreCache : IPropertyStore
{
	HRESULT GetState(REFPROPERTYKEY key, PSC_STATE *pstate);
	HRESULT GetValueAndState(REFPROPERTYKEY key, PROPVARIANT* ppropvar, PSC_STATE *pstate);
	HRESULT SetState(REFPROPERTYKEY key, PSC_STATE state);
	HRESULT SetValueAndState(REFPROPERTYKEY key, const(PROPVARIANT)* ppropvar, PSC_STATE state);
}

enum PROPENUMTYPE
{
	PET_DISCRETEVALUE,
	PET_RANGEDVALUE,
	PET_DEFAULTVALUE,
	PET_ENDRANGE,
}

immutable IID IID_IPropertyEnumType = {0x11e1fbf9, 0x2d56, 0x4a6b, [0x8d, 0xb3, 0x7c, 0xd1, 0x93, 0xa4, 0x71, 0xf2]};
interface IPropertyEnumType : IUnknown
{
	HRESULT GetEnumType(PROPENUMTYPE* penumtype);
	HRESULT GetValue(PROPVARIANT* ppropvar);
	HRESULT GetRangeMinValue(PROPVARIANT* ppropvarMin);
	HRESULT GetRangeSetValue(PROPVARIANT* ppropvarSet);
	HRESULT GetDisplayText(LPWSTR* ppszDisplay);
}

immutable IID IID_IPropertyEnumType2 = {0x9b6e051c, 0x5ddd, 0x4321, [0x90, 0x70, 0xfe, 0x2a, 0xcb, 0x55, 0xe7, 0x94]};
interface IPropertyEnumType2 : IPropertyEnumType
{
	HRESULT GetImageReference(LPWSTR* ppszImageRes);
}

immutable IID IID_IPropertyEnumTypeList = {0xa99400f4, 0x3d84, 0x4557, [0x94, 0xba, 0x12, 0x42, 0xfb, 0x2c, 0xc9, 0xa6]};
interface IPropertyEnumTypeList : IUnknown
{
	HRESULT GetCount(UINT *pctypes);
	HRESULT GetAt(UINT itype, REFIID riid, void** ppv);
	HRESULT GetConditionAt(UINT nIndex, REFIID riid, void** ppv);
	HRESULT FindMatchingIndex(REFPROPVARIANT propvarCmp, UINT* pnIndex);
}

alias DWORD PROPDESC_TYPE_FLAGS;
immutable DWORD PDTF_DEFAULT                = 0;
immutable DWORD PDTF_MULTIPLEVALUES         = 0x1;
immutable DWORD PDTF_ISINNATE               = 0x2;
immutable DWORD PDTF_ISGROUP                = 0x4;
immutable DWORD PDTF_CANGROUPBY             = 0x8;
immutable DWORD PDTF_CANSTACKBY             = 0x10;
immutable DWORD PDTF_ISTREEPROPERTY         = 0x20;
immutable DWORD PDTF_INCLUDEINFULLTEXTQUERY = 0x40;
immutable DWORD PDTF_ISVIEWABLE             = 0x80;
immutable DWORD PDTF_ISQUERYABLE            = 0x100;
immutable DWORD PDTF_CANBEPURGED            = 0x200;
immutable DWORD PDTF_SEARCHRAWVALUE         = 0x400;
immutable DWORD PDTF_ISSYSTEMPROPERTY       = 0x80000000;
immutable DWORD PDTF_MASK_ALL               = 0x800007ff;

alias DWORD PROPDESC_VIEW_FLAGS;
immutable DWORD PDVF_DEFAULT             = 0;
immutable DWORD PDVF_CENTERALIGN         = 0x1;
immutable DWORD PDVF_RIGHTALIGN          = 0x2;
immutable DWORD PDVF_BEGINNEWGROUP       = 0x4;
immutable DWORD PDVF_FILLAREA            = 0x8;
immutable DWORD PDVF_SORTDESCENDING      = 0x10;
immutable DWORD PDVF_SHOWONLYIFPRESENT   = 0x20;
immutable DWORD PDVF_SHOWBYDEFAULT       = 0x40;
immutable DWORD PDVF_SHOWINPRIMARYLIST   = 0x80;
immutable DWORD PDVF_SHOWINSECONDARYLIST = 0x100;
immutable DWORD PDVF_HIDELABEL           = 0x200;
immutable DWORD PDVF_HIDDEN              = 0x800;
immutable DWORD PDVF_CANWRAP             = 0x1000;
immutable DWORD PDVF_MASK_ALL            = 0x1bff;

enum PROPDESC_DISPLAYTYPE
{
	PDDT_STRING,
	PDDT_NUMBER,
	PDDT_BOOLEAN,
	PDDT_DATETIME,
	PDDT_ENUMERATED,
}

enum PROPDESC_GROUPING_RANGE
{
	PDGR_DISCRETE,
	PDGR_ALPHANUMERIC,
	PDGR_SIZE,
	PDGR_DYNAMIC,
	PDGR_DATE,
	PDGR_PERCENT,
	PDGR_ENUMERATED,
}

alias DWORD PROPDESC_FORMAT_FLAGS;
immutable DWORD PDFF_DEFAULT              = 0;
immutable DWORD PDFF_PREFIXNAME           = 0x1;
immutable DWORD PDFF_FILENAME             = 0x2;
immutable DWORD PDFF_ALWAYSKB             = 0x4;
immutable DWORD PDFF_RESERVED_RIGHTTOLEFT = 0x8;
immutable DWORD PDFF_SHORTTIME            = 0x10;
immutable DWORD PDFF_LONGTIME             = 0x20;
immutable DWORD PDFF_HIDETIME             = 0x40;
immutable DWORD PDFF_SHORTDATE            = 0x80;
immutable DWORD PDFF_LONGDATE             = 0x100;
immutable DWORD PDFF_HIDEDATE             = 0x200;
immutable DWORD PDFF_RELATIVEDATE         = 0x400;
immutable DWORD PDFF_USEEDITINVITATION    = 0x800;
immutable DWORD PDFF_READONLY             = 0x1000;
immutable DWORD PDFF_NOAUTOREADINGORDER   = 0x2000;

enum PROPDESC_SORTDESCRIPTION
{
	PDSD_GENERAL,
	PDSD_A_Z,
	PDSD_LOWEST_HIGHEST,
	PDSD_SMALLEST_BIGGEST,
	PDSD_OLDEST_NEWEST,
}

enum PROPDESC_RELATIVEDESCRIPTION_TYPE
{
	PDRDT_GENERAL,
	PDRDT_DATE,
	PDRDT_SIZE,
	PDRDT_COUNT,
	PDRDT_REVISION,
	PDRDT_LENGTH,
	PDRDT_DURATION,
	PDRDT_SPEED,
	PDRDT_RATE,
	PDRDT_RATING,
	PDRDT_PRIORITY,
}

enum PROPDESC_AGGREGATION_TYPE
{
	PDAT_DEFAULT,
	PDAT_FIRST,
	PDAT_SUM,
	PDAT_AVERAGE,
	PDAT_DATERANGE,
	PDAT_UNION,
	PDAT_MAX,
	PDAT_MIN,
}

enum PROPDESC_CONDITION_TYPE
{
	PDCOT_NONE,
	PDCOT_STRING,
	PDCOT_SIZE,
	PDCOT_DATETIME,
	PDCOT_BOOLEAN,
	PDCOT_NUMBER,
}

immutable IID IID_IPropertyDescription = {0x6f79d558, 0x3e96, 0x4549, [0xa1, 0xd1, 0x7d, 0x75, 0xd2, 0x28, 0x88, 0x14]};
interface IPropertyDescription : IUnknown
{
	HRESULT GetPropertyKey(PROPERTYKEY* pkey);
	HRESULT GetCanonicalName(LPWSTR* ppszName);
	HRESULT GetPropertyType(VARTYPE* pvartype);
	HRESULT GetDisplayName(LPWSTR* ppszName);
	HRESULT GetEditInvitation(LPWSTR* ppszInvite);
	HRESULT GetTypeFlags(PROPDESC_TYPE_FLAGS mask, PROPDESC_TYPE_FLAGS* ppdtFlags);
	HRESULT GetViewFlags(PROPDESC_VIEW_FLAGS* ppdvFlags);
	HRESULT GetDefaultColumnWidth(UINT* pcxChars);
	HRESULT GetDisplayType(PROPDESC_DISPLAYTYPE* pdisplaytype);
	HRESULT GetColumnState(SHCOLSTATEF* pcsFlags);
	HRESULT GetGroupingRange(PROPDESC_GROUPING_RANGE* pgr);
	HRESULT GetRelativeDescriptionType(PROPDESC_RELATIVEDESCRIPTION_TYPE* prdt);
	HRESULT GetRelativeDescription(REFPROPVARIANT propvar1, REFPROPVARIANT propvar2, LPWSTR* ppszDesc1, LPWSTR* ppszDesc2);
	HRESULT GetSortDescription(PROPDESC_SORTDESCRIPTION* psd);
	HRESULT GetSortDescriptionLabel(BOOL fDescending, LPWSTR* ppszDescription);
	HRESULT GetAggregationType(PROPDESC_AGGREGATION_TYPE* paggtype);
	HRESULT GetConditionType(PROPDESC_CONDITION_TYPE* pcontype, CONDITION_OPERATION* popDefault);
	HRESULT GetEnumTypeList(REFIID riid, void** ppv);
	HRESULT CoerceToCanonicalValue(PROPVARIANT* ppropvar);
	HRESULT FormatForDisplay(REFPROPVARIANT propvar, PROPDESC_FORMAT_FLAGS pdfFlags, LPWSTR* ppszDisplay);
	HRESULT IsValueCanonical(REFPROPVARIANT propvar);
}

HRESULT IPropertyDescription_RemoteCoerceToCanonicalValue_Proxy(IPropertyDescription This, REFPROPVARIANT propvar, PROPVARIANT* ppropvar);
void IPropertyDescription_RemoteCoerceToCanonicalValue_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IPropertyDescription2 = {0x57d2eded, 0x5062, 0x400e, [0xb1, 0x07, 0x5d, 0xae, 0x79, 0xfe, 0x57, 0xa6]};
interface IPropertyDescription2 : IPropertyDescription
{
	HRESULT GetImageReferenceForValue(REFPROPVARIANT propvar, LPWSTR* ppszImageRes);
}

immutable IID IID_IPropertyDescriptionAliasInfo = {0xf67104fc, 0x2af9, 0x46fd, [0xb3, 0x2d, 0x24, 0x3c, 0x14, 0x04, 0xf3, 0xd1]};
interface IPropertyDescriptionAliasInfo : IPropertyDescription
{
	HRESULT GetSortByAlias(REFIID riid, void** ppv);
	HRESULT GetAdditionalSortByAliases(REFIID riid, void** ppv);
}

alias DWORD PROPDESC_SEARCHINFO_FLAGS;
immutable DWORD PDSIF_DEFAULT         = 0;
immutable DWORD PDSIF_ININVERTEDINDEX = 0x1;
immutable DWORD PDSIF_ISCOLUMN        = 0x2;
immutable DWORD PDSIF_ISCOLUMNSPARSE  = 0x4;
immutable DWORD PDSIF_ALWAYSINCLUDE   = 0x8;

enum PROPDESC_COLUMNINDEX_TYPE
{
	PDCIT_NONE,
	PDCIT_ONDISK,
	PDCIT_INMEMORY,
	PDCIT_ONDEMAND,
	PDCIT_ONDISKALL,
	PDCIT_ONDISKVECTOR,
}

immutable IID IID_IPropertyDescriptionSearchInfo = {0x078f91bd, 0x29a2, 0x440f, [0x92, 0x4e, 0x46, 0xa2, 0x91, 0x52, 0x45, 0x20]};
interface IPropertyDescriptionSearchInfo : IPropertyDescription
{
	HRESULT GetSearchInfoFlags(PROPDESC_SEARCHINFO_FLAGS* ppdsiFlags);
	HRESULT GetColumnIndexType(PROPDESC_COLUMNINDEX_TYPE* ppdciType);
	HRESULT GetProjectionString(LPWSTR* ppszProjection);
	HRESULT GetMaxSize(UINT* pcbMaxSize);
}

immutable IID IID_IPropertyDescriptionRelatedPropertyInfo = {0x507393f4, 0x2a3d, 0x4a60, [0xb5, 0x9e, 0xd9, 0xc7, 0x57, 0x16, 0xc2, 0xdd]};
interface IPropertyDescriptionRelatedPropertyInfo : IPropertyDescription
{
	HRESULT GetRelatedProperty(LPCWSTR pszRelationshipName, REFIID riid, void** ppv);
}

enum PROPDESC_ENUMFILTER
{
	PDEF_ALL,
	PDEF_SYSTEM,
	PDEF_NONSYSTEM,
	PDEF_VIEWABLE,
	PDEF_QUERYABLE,
	PDEF_INFULLTEXTQUERY,
	PDEF_COLUMN,
}

immutable IID IID_IPropertySystem = {0xca724e8a, 0xc3e6, 0x442b, [0x88, 0xa4, 0x6f, 0xb0, 0xdb, 0x80, 0x35, 0xa3]};
interface IPropertySystem : IUnknown
{
	HRESULT GetPropertyDescription(REFPROPERTYKEY propkey, REFIID riid, void** ppv);
	HRESULT GetPropertyDescriptionByName(LPCWSTR pszCanonicalName, REFIID riid, void** ppv);
	HRESULT GetPropertyDescriptionListFromString(LPCWSTR pszPropList, REFIID riid, void** ppv);
	HRESULT EnumeratePropertyDescriptions(PROPDESC_ENUMFILTER filterOn, REFIID riid, void** ppv);
	HRESULT FormatForDisplay(REFPROPERTYKEY key, REFPROPVARIANT propvar, PROPDESC_FORMAT_FLAGS pdff, LPWSTR pszText, DWORD cchText);
	HRESULT FormatForDisplayAlloc(REFPROPERTYKEY key, REFPROPVARIANT propvar, PROPDESC_FORMAT_FLAGS pdff, LPWSTR* ppszDisplay);
	HRESULT RegisterPropertySchema(LPCWSTR pszPath);
	HRESULT UnregisterPropertySchema(LPCWSTR pszPath);
	HRESULT RefreshPropertySchema();
}

immutable IID IID_IPropertyDescriptionList = {0x1f9fc1d0, 0xc39b, 0x4b26, [0x81, 0x7f, 0x01, 0x19, 0x67, 0xd3, 0x44, 0x0e]};
interface IPropertyDescriptionList : IUnknown
{
	HRESULT GetCount(UINT* pcElem);
	HRESULT GetAt(UINT iElem, REFIID riid, void** ppv);
}

immutable IID IID_IPropertyStoreFactory = {0xbc110b6d, 0x57e8, 0x4148, [0xa9, 0xc6, 0x91, 0x01, 0x5a, 0xb2, 0xf3, 0xa5]};
interface IPropertyStoreFactory : IUnknown
{
	HRESULT GetPropertyStore(GETPROPERTYSTOREFLAGS flags, IUnknown pUnkFactory, REFIID riid, void** ppv);
	HRESULT GetPropertyStoreForKeys(const(PROPERTYKEY)* rgKeys, UINT cKeys, GETPROPERTYSTOREFLAGS flags, REFIID riid, void** ppv);
}

immutable IID IID_IDelayedPropertyStoreFactory = {0x40d4577f, 0xe237, 0x4bdb, [0xbd, 0x69, 0x58, 0xf0, 0x89, 0x43, 0x1b, 0x6a]};
interface IDelayedPropertyStoreFactory : IPropertyStoreFactory
{
	HRESULT GetDelayedPropertyStore(GETPROPERTYSTOREFLAGS flags, DWORD dwStoreId, REFIID riid, void** ppv);
}

alias int PERSIST_SPROPSTORE_FLAGS;
immutable int FPSPS_DEFAULT  = 0;
immutable int FPSPS_READONLY = 0x1;


struct SERIALIZEDPROPSTORAGE
{
}
alias SERIALIZEDPROPSTORAGE* PUSERIALIZEDPROPSTORAGE;
alias const(SERIALIZEDPROPSTORAGE)* PCUSERIALIZEDPROPSTORAGE;

immutable IID IID_IPersistSerializedPropStorage = {0xe318ad57, 0x0aa0, 0x450f, [0xac, 0xa5, 0x6f, 0xab, 0x71, 0x03, 0xd9, 0x17]};
interface IPersistSerializedPropStorage : IUnknown
{
	HRESULT SetFlags(PERSIST_SPROPSTORE_FLAGS flags);
	HRESULT SetPropertyStorage(PCUSERIALIZEDPROPSTORAGE psps, DWORD cb);
	HRESULT GetPropertyStorage(SERIALIZEDPROPSTORAGE** ppsps, DWORD* pcb);
}

immutable IID IID_IPersistSerializedPropStorage2 = {0x77effa68, 0x4f98, 0x4366, [0xba, 0x72, 0x57, 0x3b, 0x3d, 0x88, 0x05, 0x71]};
interface IPersistSerializedPropStorage2 : IPersistSerializedPropStorage
{
	HRESULT GetPropertyStorageSize(DWORD* pcb);
	HRESULT GetPropertyStorageBuffer(SERIALIZEDPROPSTORAGE* psps, DWORD cb, DWORD* pcbWritten);
}

immutable IID IID_IPropertySystemChangeNotify = {0xfa955fd9, 0x38be, 0x4879, [0xa6, 0xce, 0x82, 0x4c, 0xf5, 0x2d, 0x60, 0x9f]};
interface IPropertySystemChangeNotify : IUnknown
{
	HRESULT SchemaRefreshed();
}

immutable IID IID_ICreateObject = {0x75121952, 0xe0d0, 0x43e5, [0x93, 0x80, 0x1d, 0x80, 0x48, 0x3a, 0xcf, 0x72]};
interface ICreateObject : IUnknown
{
	HRESULT CreateObject(REFCLSID clsid, IUnknown pUnkOuter, REFIID riid, void** ppv);
}


HRESULT PSFormatForDisplay(REFPROPERTYKEY propkey, REFPROPVARIANT propvar, PROPDESC_FORMAT_FLAGS pdfFlags, LPWSTR pwszText, DWORD cchText);
HRESULT PSFormatForDisplayAlloc(REFPROPERTYKEY key, REFPROPVARIANT propvar, PROPDESC_FORMAT_FLAGS pdff, PWSTR* ppszDisplay);
HRESULT PSFormatPropertyValue(IPropertyStore pps, IPropertyDescription ppd, PROPDESC_FORMAT_FLAGS pdff, LPWSTR* ppszDisplay);
HRESULT PSGetImageReferenceForValue(REFPROPERTYKEY propkey, REFPROPVARIANT propvar, PWSTR* ppszImageRes);

immutable size_t PKEY_PIDSTR_MAX = 10;
immutable size_t GUIDSTRING_MAX  = 1 + 8 + 1 + 4 + 1 + 4 + 1 + 4 + 1 + 12 + 1 + 1;
immutable size_t PKEYSTR_MAX     = GUIDSTRING_MAX + 1 + PKEY_PIDSTR_MAX;

HRESULT PSStringFromPropertyKey(REFPROPERTYKEY pkey, LPWSTR psz, UINT cch);
HRESULT PSPropertyKeyFromString(LPCWSTR pszString, PROPERTYKEY* pkey);
HRESULT PSCreateMemoryPropertyStore(REFIID riid, void** ppv);
HRESULT PSCreateDelayedMultiplexPropertyStore(GETPROPERTYSTOREFLAGS flags, IDelayedPropertyStoreFactory pdpsf, const(DWORD)* rgStoreIds, DWORD cStores, REFIID riid, void** ppv);
HRESULT PSCreateMultiplexPropertyStore(IUnknown* prgpunkStores, DWORD cStores, REFIID riid, void** ppv);
HRESULT PSCreatePropertyChangeArray(const(PROPERTYKEY)* rgpropkey, const(PKA_FLAGS)* rgflags, const(PROPVARIANT)* rgpropvar, UINT cChanges, REFIID riid, void** ppv);
HRESULT PSCreateSimplePropertyChange(PKA_FLAGS flags, REFPROPERTYKEY key, REFPROPVARIANT propvar, REFIID riid, void** ppv);
HRESULT PSGetPropertyDescription(REFPROPERTYKEY propkey, REFIID riid, void** ppv);
HRESULT PSGetPropertyDescriptionByName(LPCWSTR pszCanonicalName, REFIID riid, void** ppv);
HRESULT PSLookupPropertyHandlerCLSID(PCWSTR pszFilePath, CLSID* pclsid);
HRESULT PSGetItemPropertyHandler(IUnknown punkItem, BOOL fReadWrite, REFIID riid, void** ppv);
HRESULT PSGetItemPropertyHandlerWithCreateObject(IUnknown punkItem, BOOL fReadWrite, IUnknown punkCreateObject, REFIID riid, void** ppv);
HRESULT PSGetPropertyValue(IPropertyStore pps, IPropertyDescription ppd, PROPVARIANT* ppropvar);
HRESULT PSSetPropertyValue(IPropertyStore pps, IPropertyDescription ppd, REFPROPVARIANT propvar);
HRESULT PSRegisterPropertySchema(PCWSTR pszPath);
HRESULT PSUnregisterPropertySchema(PCWSTR pszPath);
HRESULT PSRefreshPropertySchema();
HRESULT PSEnumeratePropertyDescriptions(PROPDESC_ENUMFILTER filterOn, REFIID riid, void** ppv);
HRESULT PSGetPropertyKeyFromName(PCWSTR pszName, PROPERTYKEY* ppropkey);
HRESULT PSGetNameFromPropertyKey(REFPROPERTYKEY propkey, PWSTR* ppszCanonicalName);
HRESULT PSCoerceToCanonicalValue(REFPROPERTYKEY key, PROPVARIANT* ppropvar);
HRESULT PSGetPropertyDescriptionListFromString(LPCWSTR pszPropList, REFIID riid, void** ppv);
HRESULT PSCreatePropertyStoreFromPropertySetStorage(IPropertySetStorage ppss, DWORD grfMode, REFIID riid, void** ppv);
HRESULT PSCreatePropertyStoreFromObject(IUnknown punk, DWORD grfMode, REFIID riid, void** ppv);
HRESULT PSCreateAdapterFromPropertyStore(IPropertyStore pps, REFIID riid, void** ppv);
HRESULT PSGetPropertySystem(REFIID riid, void** ppv);
HRESULT PSGetPropertyFromPropertyStorage(PCUSERIALIZEDPROPSTORAGE psps, DWORD cb, REFPROPERTYKEY rpkey, PROPVARIANT* ppropvar);
HRESULT PSGetNamedPropertyFromPropertyStorage(PCUSERIALIZEDPROPSTORAGE psps, DWORD cb, LPCWSTR pszName, PROPVARIANT* ppropvar);
HRESULT PSPropertyBag_ReadType(IPropertyBag propBag, LPCWSTR propName, VARIANT* var, VARTYPE type);
HRESULT PSPropertyBag_ReadStr(IPropertyBag propBag, LPCWSTR propName, LPWSTR value, int characterCount);
HRESULT PSPropertyBag_ReadStrAlloc(IPropertyBag propBag, LPCWSTR propName, PWSTR* value);
HRESULT PSPropertyBag_ReadBSTR(IPropertyBag propBag, LPCWSTR propName, BSTR* value);
HRESULT PSPropertyBag_WriteStr(IPropertyBag propBag, LPCWSTR propName, LPCWSTR value);
HRESULT PSPropertyBag_WriteBSTR(IPropertyBag propBag, LPCWSTR propName, BSTR value);
HRESULT PSPropertyBag_ReadInt(IPropertyBag propBag, LPCWSTR propName, INT* value);
HRESULT PSPropertyBag_WriteInt(IPropertyBag propBag, LPCWSTR propName, INT value);
HRESULT PSPropertyBag_ReadSHORT(IPropertyBag propBag, LPCWSTR propName, SHORT* value);
HRESULT PSPropertyBag_WriteSHORT(IPropertyBag propBag, LPCWSTR propName, SHORT value);
HRESULT PSPropertyBag_ReadLONG(IPropertyBag propBag, LPCWSTR propName, LONG* value);
HRESULT PSPropertyBag_WriteLONG(IPropertyBag propBag, LPCWSTR propName, LONG value);
HRESULT PSPropertyBag_ReadDWORD(IPropertyBag propBag, LPCWSTR propName, DWORD* value);
HRESULT PSPropertyBag_WriteDWORD(IPropertyBag propBag, LPCWSTR propName, DWORD value);
HRESULT PSPropertyBag_ReadBOOL(IPropertyBag propBag, LPCWSTR propName, BOOL* value);
HRESULT PSPropertyBag_WriteBOOL(IPropertyBag propBag, LPCWSTR propName, BOOL value);
HRESULT PSPropertyBag_ReadPOINTL(IPropertyBag propBag, LPCWSTR propName, POINTL* value);
HRESULT PSPropertyBag_WritePOINTL(IPropertyBag propBag, LPCWSTR propName, const(POINTL)* value);
HRESULT PSPropertyBag_ReadPOINTS(IPropertyBag propBag, LPCWSTR propName, POINTS* value);
HRESULT PSPropertyBag_WritePOINTS(IPropertyBag propBag, LPCWSTR propName, const(POINTS)* value);
HRESULT PSPropertyBag_ReadRECTL(IPropertyBag propBag, LPCWSTR propName, RECTL* value);
HRESULT PSPropertyBag_WriteRECTL(IPropertyBag propBag, LPCWSTR propName, const(RECTL)* value);
HRESULT PSPropertyBag_ReadStream(IPropertyBag propBag, LPCWSTR propName, IStream* value);
HRESULT PSPropertyBag_WriteStream(IPropertyBag propBag, LPCWSTR propName, IStream value);
HRESULT PSPropertyBag_Delete(IPropertyBag propBag, LPCWSTR propName);
HRESULT PSPropertyBag_ReadULONGLONG(IPropertyBag propBag, LPCWSTR propName, ULONGLONG* value);
HRESULT PSPropertyBag_WriteULONGLONG(IPropertyBag propBag, LPCWSTR propName, ULONGLONG value);
HRESULT PSPropertyBag_ReadUnknown(IPropertyBag propBag, LPCWSTR propName, REFIID riid, void** ppv);
HRESULT PSPropertyBag_WriteUnknown(IPropertyBag propBag, LPCWSTR propName, IUnknown punk);
HRESULT PSPropertyBag_ReadGUID(IPropertyBag propBag, LPCWSTR propName, GUID* value);
HRESULT PSPropertyBag_WriteGUID(IPropertyBag propBag, LPCWSTR propName, const(GUID)* value);
HRESULT PSPropertyBag_ReadPropertyKey(IPropertyBag propBag, LPCWSTR propName, PROPERTYKEY *value);
HRESULT PSPropertyBag_WritePropertyKey(IPropertyBag propBag, LPCWSTR propName, REFPROPERTYKEY value);


immutable IID LIBID_PropSysObjects = {0x2cda3294, 0x6c4f, 0x4020, [0xb1, 0x61, 0x27, 0xc5, 0x30, 0xc8, 0x1f, 0xa6]};

immutable CLSID CLSID_InMemoryPropertyStore = {0x9a02e012, 0x6303, 0x4e1e, [0xb9, 0xa1, 0x63, 0x0f, 0x80, 0x25, 0x92, 0xc5]};
immutable CLSID CLSID_PropertySystem = {0xb8967f85, 0x58ae, 0x4f46, [0x9f, 0xb2, 0x5d, 0x79, 0x04, 0x79, 0x8f, 0x4b]};

alias jp.ku6.windows.win32api.propidl.BSTR_UserSize BSTR_UserSize;
alias jp.ku6.windows.win32api.propidl.BSTR_UserMarshal BSTR_UserMarshal;
alias jp.ku6.windows.win32api.propidl.BSTR_UserUnmarshal BSTR_UserMarshal;
alias jp.ku6.windows.win32api.propidl.BSTR_UserFree BSTR_UserFree;

alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserSize LPSAFEARRAY_UserSize;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserMarshal LPSAFEARRAY_UserMarshal;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserUnmarshal LPSAFEARRAY_UserUnmarshal;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserFree LPSAFEARRAY_UserFree;

alias jp.ku6.windows.win32api.propidl.BSTR_UserSize64 BSTR_UserSize64;
alias jp.ku6.windows.win32api.propidl.BSTR_UserMarshal64 BSTR_UserMarshal64;
alias jp.ku6.windows.win32api.propidl.BSTR_UserUnmarshal64 BSTR_UserUnmarshal64;
alias jp.ku6.windows.win32api.propidl.BSTR_UserFree64 BSTR_UserFree64;

alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserSize64 LPSAFEARRAY_UserSize64;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserMarshal64 LPSAFEARRAY_UserMarshal64;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserUnmarshal64 LPSAFEARRAY_UserUnmarshal64;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserFree64 LPSAFEARRAY_UserFree64;

HRESULT IInitializeWithStream_Initialize_Proxy(IInitializeWithStream This, IStream pstream, DWORD grfMode);
HRESULT IInitializeWithStream_Initialize_Stub(IInitializeWithStream This, IStream pstream, DWORD grfMode);
HRESULT IPropertyDescription_CoerceToCanonicalValue_Proxy(IPropertyDescription This, PROPVARIANT* ppropvar);
HRESULT IPropertyDescription_CoerceToCanonicalValue_Stub(IPropertyDescription This, REFPROPVARIANT propvar, PROPVARIANT* ppropvar);

