module jp.ku6.windows.win32api.shtypes;

import jp.ku6.windows.win32api.w32api;
import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.wtypes;
import jp.ku6.windows.win32api.winbase;
import jp.ku6.windows.win32api.windef;

extern (Windows):

align (1)
struct SHITEMID
{
	USHORT cb;
	BYTE[1] abID;
}
alias SHITEMID* LPSHITEMID;
alias const(SHITEMID)* LPCSHITEMID;

align (1)
struct ITEMIDLIST
{
	SHITEMID mkid;
}
alias ITEMIDLIST* LPITEMIDLIST;
alias const(ITEMIDLIST)* LPCITEMIDLIST;

alias ITEMIDLIST ITEMIDLIST_RELATIVE;
alias ITEMIDLIST_RELATIVE* PIDLIST_RELATIVE;
alias ITEMIDLIST_RELATIVE* PUIDLIST_RELATIVE;
alias const(ITEMIDLIST_RELATIVE)* PCIDLIST_RELATIVE;
alias const(ITEMIDLIST_RELATIVE)* PCUIDLIST_RELATIVE;
alias const(PCUIDLIST_RELATIVE)* PCUIDLIST_RELATIVE_ARRAY;

alias ITEMIDLIST_RELATIVE ITEMID_CHILD;
alias ITEMID_CHILD* PITEMID_CHILD;
alias ITEMID_CHILD* PUITEMID_CHILD;
alias const(ITEMID_CHILD)* PCITEMID_CHILD;
alias const(ITEMID_CHILD)* PCUITEMID_CHILD;
alias const(PCUITEMID_CHILD)* PCUITEMID_CHILD_ARRAY;

alias ITEMIDLIST_RELATIVE ITEMIDLIST_ABSOLUTE;
alias ITEMIDLIST_ABSOLUTE* PIDLIST_ABSOLUTE;
alias const(ITEMIDLIST_ABSOLUTE)* PCIDLIST_ABSOLUTE;
alias const(ITEMIDLIST_ABSOLUTE )*PCUIDLIST_ABSOLUTE;
alias const(PCIDLIST_ABSOLUTE)* PCIDLIST_ABSOLUTE_ARRAY;
alias const(PCUIDLIST_ABSOLUTE)* PCUIDLIST_ABSOLUTE_ARRAY;

alias BYTE_BLOB* wirePIDL;

enum STRRET_TYPE
{
	STRRET_WSTR   = 0,
	STRRET_OFFSET = 0x1,
	STRRET_CSTR   = 0x2
}

align (8)
struct STRRET
{
	UINT uType;
	union
	{
		LPWSTR pOleStr;
		UINT uOffset;
		char[260] cStr;
	};
}
alias STRRET* LPSTRRET;

align (1)
struct SHELLDETAILS
{
	int fmt;
	int cxChar;
	STRRET str;
}
alias SHELLDETAILS* LPSHELLDETAILS;

static if (_WIN32_IE >= _WIN32_IE_IE60SP2)
{
	enum PERCEIVED
	{
		PERCEIVED_TYPE_FIRST       = -3,
		PERCEIVED_TYPE_CUSTOM      = -3,
		PERCEIVED_TYPE_UNSPECIFIED = -2,
		PERCEIVED_TYPE_FOLDER      = -1,
		PERCEIVED_TYPE_UNKNOWN     = 0,
		PERCEIVED_TYPE_TEXT        = 1,
		PERCEIVED_TYPE_IMAGE       = 2,
		PERCEIVED_TYPE_AUDIO       = 3,
		PERCEIVED_TYPE_VIDEO       = 4,
		PERCEIVED_TYPE_COMPRESSED  = 5,
		PERCEIVED_TYPE_DOCUMENT    = 6,
		PERCEIVED_TYPE_SYSTEM      = 7,
		PERCEIVED_TYPE_APPLICATION = 8,
		PERCEIVED_TYPE_GAMEMEDIA   = 9,
		PERCEIVED_TYPE_CONTACTS    = 10,
		PERCEIVED_TYPE_LAST        = 10
	}

	alias DWORD PERCEIVEDFLAG;
	immutable DWORD PERCEIVEDFLAG_UNDEFINED     = 0x0000;
	immutable DWORD PERCEIVEDFLAG_SOFTCODED     = 0x0001;
	immutable DWORD PERCEIVEDFLAG_HARDCODED     = 0x0002;
	immutable DWORD PERCEIVEDFLAG_NATIVESUPPORT = 0x0004;
	immutable DWORD PERCEIVEDFLAG_GDIPLUS       = 0x0010;
	immutable DWORD PERCEIVEDFLAG_WMSDK         = 0x0020;
	immutable DWORD PERCEIVEDFLAG_ZIPFOLDER     = 0x0040;
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	struct COMDLG_FILTERSPEC
	{
		LPCWSTR pszName;
		LPCWSTR pszSpec;
	}
}

alias DWORD KF_REDIRECT_FLAGS;
alias GUID KNOWNFOLDERID;
alias const(KNOWNFOLDERID)* REFKNOWNFOLDERID;
alias GUID FOLDERTYPEID;
alias const(FOLDERTYPEID)* REFFOLDERTYPEID;
alias GUID TASKOWNERID;
alias const(TASKOWNERID)* REFTASKOWNERID;


struct LOGFONTA
{
	LONG lfHeight;
	LONG lfWidth;
	LONG lfEscapement;
	LONG lfOrientation;
	LONG lfWeight;
	BYTE lfItalic;
	BYTE lfUnderline;
	BYTE lfStrikeOut;
	BYTE lfCharSet;
	BYTE lfOutPrecision;
	BYTE lfClipPrecision;
	BYTE lfQuality;
	BYTE lfPitchAndFamily;
	CHAR[32] lfFaceName;
}

struct LOGFONTW
{
	LONG lfHeight;
	LONG lfWidth;
	LONG lfEscapement;
	LONG lfOrientation;
	LONG lfWeight;
	BYTE lfItalic;
	BYTE lfUnderline;
	BYTE lfStrikeOut;
	BYTE lfCharSet;
	BYTE lfOutPrecision;
	BYTE lfClipPrecision;
	BYTE lfQuality;
	BYTE lfPitchAndFamily;
	WCHAR[32] lfFaceName;
}

version (Unicode)
{
	alias LOGFONTW LOGFONT;
}
else
{
	alias LOGFONTA LOGFONT;
}

alias DWORD SHCOLSTATEF;
immutable DWORD SHCOLSTATE_DEFAULT            = 0;
immutable DWORD SHCOLSTATE_TYPE_STR           = 0x1;
immutable DWORD SHCOLSTATE_TYPE_INT           = 0x2;
immutable DWORD SHCOLSTATE_TYPE_DATE          = 0x3;
immutable DWORD SHCOLSTATE_TYPEMASK           = 0xf;
immutable DWORD SHCOLSTATE_ONBYDEFAULT        = 0x10;
immutable DWORD SHCOLSTATE_SLOW               = 0x20;
immutable DWORD SHCOLSTATE_EXTENDED           = 0x40;
immutable DWORD SHCOLSTATE_SECONDARYUI        = 0x80;
immutable DWORD SHCOLSTATE_HIDDEN             = 0x100;
immutable DWORD SHCOLSTATE_PREFER_VARCMP      = 0x200;
immutable DWORD SHCOLSTATE_PREFER_FMTCMP      = 0x400;
immutable DWORD SHCOLSTATE_NOSORTBYFOLDERNESS = 0x800;
immutable DWORD SHCOLSTATE_VIEWONLY           = 0x10000;
immutable DWORD SHCOLSTATE_BATCHREAD          = 0x20000;
immutable DWORD SHCOLSTATE_NO_GROUPBY         = 0x40000;
immutable DWORD SHCOLSTATE_FIXED_WIDTH        = 0x1000;
immutable DWORD SHCOLSTATE_NODPISCALE         = 0x2000;
immutable DWORD SHCOLSTATE_FIXED_RATIO        = 0x4000;
immutable DWORD SHCOLSTATE_DISPLAYMASK        = 0xf000;

alias PROPERTYKEY SHCOLUMNID;
alias const(SHCOLUMNID)* LPCSHCOLUMNID;

